/*
  Copyright 2009 CNRS-LAAS

  Author: Oussama Kanoun
*/

#ifndef HPP_LOS_FEET_ANTI_COLLISION_TASK_H
#define HPP_LOS_FEET_ANTI_COLLISION_TASK_H

#include "hpplocalstepper/tasks/hppLosTask.hh"
class ChppLosLink;
/**
A task to avoid footprints overlapping.
\ingroup tasks
 */
class ChppLosFeetAntiCollisionTask: public ChppLosTask
{
    public:
       /**
        \brief Constructor
        */
        ChppLosFeetAntiCollisionTask(ChppLosCentipede& inCentipede, ChppLosLink& inLink);
        /**
        \brief Set the area of translation brake inside the authorized configurations region boudaries
         */
        void setMargins ( double inDi, double inDs, double inXi );
        /**
        \brief Inherited.
         */
        bool isEqualityTask() const {return false;};
        /**
        \brief Inherited.
         */
        void computeDifferentialSystem();
        /**
        \brief Inherited.
         */
        const vectorN& currentValue();
        
    private:
        
        ChppLosLink* attLink;
        double attStepXi,attStepDi,attStepDs;
};

#endif
