/*
  Copyright 2009 CNRS-LAAS

  Author: Oussama Kanoun
*/

#ifndef HPP_LOCALSTEPPER_TEST_H
#define HPP_LOCALSTEPPER_TEST_H

#include <list>
#include <string>
#include <iostream>

#include "MatrixAbstractLayer/MatrixAbstractLayer.h"
#include <boost/numeric/bindings/traits/ublas_matrix.hpp>

class ChppLosCentipede;
class ChppGikStandingRobot;
class ChppLosLink;

class ChppLocalStepperTest
{
    public:

        ChppLocalStepperTest(const std::string& inPath);

        ~ChppLocalStepperTest();
    
        void plan();
    
    private:
        ChppGikStandingRobot* createHumanoidRobot(const std::string& inPath);
        void createCentipede(const std::string& inPath);
        void dumpSolution(const char* inFilename, const std::list<vectorN>& inSolution);
        std::list<ChppLosLink*> attCentipedeParts;
        vectorN attMask;
        std::vector<ChppGikStandingRobot*> standingRobots;
        std::vector<ChppLosCentipede*> centipedes;
        ChppLosCentipede* attCentipede;
        vectorN initialConfig;
        vector3d finalCom;
        
        std::string attpath;
};

#endif

